with Dates;
with Dates.Lists;
use type Dates.Lists.List_T;
with Ada.Text_IO;

procedure Main is
   Valid : constant Dates.Lists.List_T
      := [
      Dates.Make ("2000/02/28"),
      Dates.Make ("2000/02/29"),
      Dates.Make ("2000/12/31"),
      Dates.Make ("2004/02/29")
      ];
   pragma Assert (Dates.Lists.All_Valid (Valid));

   Invalid : constant Dates.Lists.List_T
      := [
      Dates.Make ("2100/02/29")
      ];
   pragma Assert (not Dates.Lists.Some_Valid (Invalid));

   All_Dates : constant Dates.Lists.List_T := Valid & Invalid;
begin
   for D of All_Dates loop
      Ada.Text_IO.Put_Line (D'Image);
   end loop;
end Main;
